/***************************************************
* C source with CCS
*  File Name: 20170103K471MK308B1571.c
 * rev 1.0
*  Description: 
*  PIN A0 for mode
*  PIN A1 for relay
*  PIN A2 for na
*  PIN A3 for stop/reset
*  PIN A4 for pot
*  PIN A5 for start
***************************************************/
// include headre file
#include   <12f1571.h>
#DEVICE ADC=10
// settings
#fuses   INTRC_IO, NOWDT, NOMCLR, NOBROWNOUT, PUT, NOLVP, NOPROTECT, NODEBUG
#fuses   NOCLKOUT, NOWRT, PLL_SW, NOSTVREN
#use delay(CLOCK = 4000000)
#use   fast_io(a)
//
#byte WPUA = 0x20C
#byte OPTION_REG = 0x095
//
#define Amode 0x3D
#define startsw PIN_A5
#define stopsw PIN_A3
#define modesw PIN_A0
#define relay PIN_A1
// variables
long count_value = 0;
long set_time = 10;
// prototyping
#separate
void initializing();
#separate
void get_pot();
// main function
void main()
{
   initializing();
   // main loop
   while(1)
   {
        get_pot();   // get value from potentiometer
        //
        if(input(startsw) == 0)
        {
            delay_ms(50);
            if(input(startsw) == 0)
            {
                //set it again and restart
                count_value = set_time;
                if(input(modesw) == 1)
                {
                    output_high(relay);
                }
                else output_low(relay);
            }
            while(input(startsw) == 0) {}
        }
        if(input(stopsw) == 0)
        {
            delay_ms(50);
            if(input(stopsw) == 0)
            {
                //resert
                count_value = 0;
                if(input(modesw) == 1)
                {
                    output_low(relay);
                }
                else output_high(relay);
            }
            while(input(stopsw) == 0) {}
        }
        if(input(modesw) == 1)  // 1 = normal, 0 = delayed
        {
            if(count_value > 1) output_high(relay);
            else output_low(relay);
        }
        else if(count_value > 1) output_low(relay);
        else output_high(relay);
   }
}
//
#separate
void initializing()
{
    set_tris_a(Amode);   //
    // A/D converter initialize AN0
    setup_adc_ports(sAN3 | VSS_VDD);   // gnd to 5v
    setup_adc(ADC_CLOCK_DIV_8);         // 2usec
    //
    output_low(relay);
    OPTION_REG = 0x7F & OPTION_REG;	// pull up enable
    WPUA = 0x29;	// pull up A5, 3, 0
    // initialize timer 1
    setup_timer_1(T1_INTERNAL|T1_DIV_BY_8); //8us
    set_timer1(0xE797);              // timer 1 setting almost 50msec
    enable_interrupts(INT_TIMER1);   // timer 1 enable
    enable_interrupts(GLOBAL);       // global enable    
}
//
#separate
void get_pot()
{
   set_adc_channel(3);   //must wait 65u, AN8
   delay_us(100);
   set_time = read_adc();   // 0 to 1023, 0V to 5V
   float timef;
   timef = set_time;    // 0 to 1023
   timef = timef / 10; // 0 to 102.3
   set_time = timef * timef;    // 0 to 10465
   set_time = set_time + 20;    // 20 to 10485, 1sec to 524sec
}
// timer 1 inturruption
#int_timer1
void isr1(void)
{
   set_timer1(0xE797);             // timer 1 almost 50msec
   //
   if(count_value > 1) count_value = count_value - 1;
   else count_value = 0;
}
//


